Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/PreprocessingDataTableView.Designer.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/PreprocessingDataTableView.Designer.cs	(revision 10546)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/PreprocessingDataTableView.Designer.cs	(revision 10546)
@@ -0,0 +1,59 @@
+﻿namespace HeuristicLab.DataPreprocessing.Views {
+  partial class PreprocessingDataTableView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      ((System.ComponentModel.ISupportInitialize)(this.chart)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // chart
+      // 
+      this.chart.Size = new System.Drawing.Size(347, 248);
+      // 
+      // nameTextBox
+      // 
+      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
+      this.nameTextBox.Size = new System.Drawing.Size(267, 20);
+      // 
+      // infoLabel
+      // 
+      this.infoLabel.Location = new System.Drawing.Point(328, 3);
+      // 
+      // PreprocessingDataTableView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Name = "PreprocessingDataTableView";
+      this.Size = new System.Drawing.Size(347, 274);
+      ((System.ComponentModel.ISupportInitialize)(this.chart)).EndInit();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+  }
+}
Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/PreprocessingDataTableView.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/PreprocessingDataTableView.cs	(revision 10546)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/Views/PreprocessingDataTableView.cs	(revision 10546)
@@ -0,0 +1,42 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Data.Views;
+using HeuristicLab.Analysis;
+using HeuristicLab.Analysis.Views;
+
+namespace HeuristicLab.DataPreprocessing.Views {
+
+  [View("Preprocessing Data Table View")]
+  [Content(typeof(DataTable), false)]
+  public partial class PreprocessingDataTableView : DataTableView {
+
+    public new DataTable Content {
+      get { return (DataTable)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public PreprocessingDataTableView() {
+      InitializeComponent();
+
+      this.Controls.Remove(nameLabel);
+      this.Controls.Remove(nameTextBox);
+      this.Controls.Remove(infoLabel);
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content != null) {
+      }
+    }
+
+  }
+}